#include <iostream>
#include <fstream>
#include <sstream>
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/calib3d/calib3d.hpp>



std::vector< cv::Point2f > src_pts;


void mouse_callback_handler(int event, int x, int y, int flags, void *userdata)
{

    if (event == cv::EVENT_LBUTTONDOWN )
    {
        src_pts.push_back( cv::Point2f(x,y));
        std::cout << "Point added at coords: " << x << " " << y << std::endl;
        return;
    }
}


int main( int argc, char* argv[] )
{

    cv::Mat src = imread( "facade.jpg", cv::IMREAD_COLOR );
    //cv::Mat src = imread( "book.jpg", cv::IMREAD_COLOR );

    if( src.rows == 0 )
    {
        return -1;
    }

    cv::Size out_size(400,500);

    std::vector< cv::Point2f > dst_pts;
    dst_pts.push_back( cv::Point2f(0,0) );
    dst_pts.push_back( cv::Point2f(out_size.width,0) );
    dst_pts.push_back( cv::Point2f(out_size.width,out_size.height) );
    dst_pts.push_back( cv::Point2f(0,out_size.height) );

    cv::Mat dbg_image = src.clone();

    while( true )
    {
        cv::imshow("image", dbg_image);
        cv::setMouseCallback("image", mouse_callback_handler);
        if( cv::waitKey(16)=='q' )
            break;

        for( int ii=0; ii<src_pts.size(); ++ii )
        {
            cv::line( dbg_image, src_pts[ii%src_pts.size()], src_pts[ (ii+1)%src_pts.size()],cv::Scalar(255,0,0),2,8);
        }

        if( src_pts.size() == 4 )
        {
            cv::imshow("image", dbg_image);
            cv::Mat H = cv::findHomography( src_pts, dst_pts );

            cv::Mat warped_img;
            cv::warpPerspective( src, warped_img, H, out_size );
            cv::imshow("warped", warped_img );
            cv::waitKey(0);
            dbg_image = src.clone();
            src_pts.clear();
            cv::destroyWindow("warped");
        }
    }

}


